# Generated by Django 4.1.3 on 2022-11-05 19:15

import functools

import django.db.models.deletion
from django.conf import settings
from django.db import migrations, models

import users.models.identity


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="User",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("password", models.CharField(max_length=128, verbose_name="password")),
                (
                    "last_login",
                    models.DateTimeField(
                        blank=True, null=True, verbose_name="last login"
                    ),
                ),
                ("email", models.EmailField(max_length=254, unique=True)),
                ("admin", models.BooleanField(default=False)),
                ("moderator", models.BooleanField(default=False)),
                ("banned", models.BooleanField(default=False)),
                ("deleted", models.BooleanField(default=False)),
                ("created", models.DateTimeField(auto_now_add=True)),
                ("updated", models.DateTimeField(auto_now=True)),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="UserEvent",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("date", models.DateTimeField(auto_now_add=True)),
                (
                    "type",
                    models.CharField(
                        choices=[
                            ("created", "Created"),
                            ("reset_password", "Reset Password"),
                            ("banned", "Banned"),
                        ],
                        max_length=100,
                    ),
                ),
                ("data", models.JSONField(blank=True, null=True)),
                (
                    "user",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="events",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Identity",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("handle", models.CharField(max_length=500, unique=True)),
                ("name", models.CharField(blank=True, max_length=500, null=True)),
                ("bio", models.TextField(blank=True, null=True)),
                (
                    "profile_image",
                    models.ImageField(
                        upload_to=functools.partial(
                            users.models.identity.upload_namer,
                            *("profile_images",),
                            **{},
                        )
                    ),
                ),
                (
                    "background_image",
                    models.ImageField(
                        upload_to=functools.partial(
                            users.models.identity.upload_namer,
                            *("background_images",),
                            **{},
                        )
                    ),
                ),
                ("local", models.BooleanField()),
                ("private_key", models.BinaryField(blank=True, null=True)),
                ("public_key", models.BinaryField(blank=True, null=True)),
                ("created", models.DateTimeField(auto_now_add=True)),
                ("updated", models.DateTimeField(auto_now=True)),
                ("deleted", models.DateTimeField(blank=True, null=True)),
                (
                    "users",
                    models.ManyToManyField(
                        related_name="identities", to=settings.AUTH_USER_MODEL
                    ),
                ),
            ],
        ),
    ]
